package com.example.demo;

import java.util.ArrayList;
import java.util.List;

import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api/book")
public class ApiController {
    private final List<BookDto> books = new ArrayList<>();

    @GetMapping
    public List<BookDto> getBooks() {
        return books;
    }

    @GetMapping("/{id}")
    public BookDto getBook(@PathVariable(name = "id") int id) {
        return books.get(id);
    }

    @PostMapping
    public BookDto postMap(@RequestBody BookDto bookDto) {
        books.add(bookDto);
        return bookDto;
    }

    @PutMapping("/{id}")
    public BookDto putMap(@RequestBody BookDto bookDto, @PathVariable(name = "id") int id) {
        books.set(id, bookDto);
        return bookDto;
    }

    @DeleteMapping("/{id}")
    public BookDto delete(@RequestParam(name = "id") int id) {
        BookDto bk = books.get(id);
        books.remove(id);
        return bk;
    }
}