package com.example.demo.books.model;

import java.util.Objects;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.genres.model.GenreEntity;

public class BookEntity extends BaseEntity {
    private GenreEntity genre;
    private String name;
    private String author;
    private String year;
    private String description;

    public BookEntity() {
        super();
    }

    public BookEntity(Integer id, GenreEntity genre, String name, String author, String year, String description) {
        super(id);
        this.genre = genre;
        this.name = name;
        this.author = author;
        this.year = year;
        this.description = description;
    }

    public GenreEntity getGenre() {
        return genre;
    }

    public void setGenre(GenreEntity genre) {
        this.genre = genre;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getYear() {
        return year;
    }

    public void setYear(String year) {
        this.year = year;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, genre, name, author, year, description);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final BookEntity other = (BookEntity) obj;
        return Objects.equals(other.getId(), id)
                && Objects.equals(other.getGenre(), genre)
                && Objects.equals(other.getName(), name)
                && Objects.equals(other.getAuthor(), author)
                && Objects.equals(other.getYear(), year)
                && Objects.equals(other.getDescription(), description);
    }
}
