package com.example.demo.users.api;

import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonProperty;

import jakarta.validation.constraints.NotBlank;
import jakarta.validation.constraints.NotNull;

public class UserDto {
    private Integer id;

    @NotBlank
    private String username;

    @NotBlank
    private String password;

    @NotNull
    private boolean isAdmin;

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    private List<Integer> books = new ArrayList<>();

    @JsonProperty(access = JsonProperty.Access.READ_ONLY)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public boolean getIsAdmin() {
        return isAdmin;
    }

    public void setIsAdmin(boolean isAdmin) {
        this.isAdmin = isAdmin;
    }

    public List<Integer> getBooks() {
        return books;
    }

    public void setBooks(List<Integer> list) {
        this.books = list;
    }
}
