package com.example.demo.users.model;

import java.util.Objects;
import java.util.Set;
import java.util.LinkedHashSet;

import com.example.demo.core.model.BaseEntity;
import com.example.demo.books.model.BookEntity;

public class UserEntity extends BaseEntity {

    private String username;
    private String password;
    private boolean isAdmin;
    private final Set<BookEntity> books = new LinkedHashSet<>();

    public UserEntity() {
        super();
    }

    public UserEntity(Integer id, String username, String password, boolean isAdmin) {
        super(id);
        this.username = username;
        this.password = password;
        this.isAdmin = isAdmin;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public boolean getIsAdmin() {
        return isAdmin;
    }

    public void setIsAdmin(boolean isAdmin) {
        this.isAdmin = isAdmin;
    }

    public Set<BookEntity> getBooks() {
        return books;
    }

    public void addBook(BookEntity book) {
        books.add(book);
    }

    public void deleteBook(BookEntity book) {
        books.remove(book);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, username);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final UserEntity other = (UserEntity) obj;
        return Objects.equals(other.getId(), id) &&
                Objects.equals(other.getUsername(), username) &&
                Objects.equals(other.getIsAdmin(), isAdmin) &&
                Objects.equals(other.getPassword(), password) &&
                Objects.equals(other.getBooks(), books);
    }
}
