package com.example.demo.books.repository;

import java.util.Optional;
import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;

import com.example.demo.books.model.BookEntity;

public interface BookRepository
        extends CrudRepository<BookEntity, Long>, PagingAndSortingRepository<BookEntity, Long> {
    Optional<BookEntity> findByNameIgnoreCase(String name);

    List<BookEntity> findByGenreId(Long genreId);

    Page<BookEntity> findByGenreId(Long genreId, PageRequest pageable);

    List<BookEntity> findByAuthorId(Long authorId);

    Page<BookEntity> findByAuthorId(Long authorId, PageRequest pageable);

    List<BookEntity> findByGenreIdAndAuthorId(Long genreId, Long authorId);

    Page<BookEntity> findByGenreIdAndAuthorId(Long genreId, Long authorId, PageRequest pageable);
}
