package com.example.demo.genres.model;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

import com.example.demo.books.model.BookEntity;
import com.example.demo.core.model.BaseEntity;

import jakarta.persistence.CascadeType;
import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;

@Entity
@Table(name = "genres")
public class GenreEntity extends BaseEntity {
    @Column(nullable = false, unique = true, length = 50)
    private String name;
    @OneToMany(mappedBy = "genre", cascade = CascadeType.ALL)
    private Set<BookEntity> books = new HashSet<>();

    public GenreEntity() {
    }

    public GenreEntity(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final GenreEntity other = (GenreEntity) obj;
        return Objects.equals(other.getId(), id) && Objects.equals(other.getName(), name);
    }
}
