package com.example.demo.favorites.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.PagingAndSortingRepository;

import com.example.demo.favorites.model.FavoriteEntity;

public interface FavoriteRepository extends CrudRepository<FavoriteEntity, Long>,
        PagingAndSortingRepository<FavoriteEntity, Long> {
    List<FavoriteEntity> findByUserId(Long userId);

    List<FavoriteEntity> findByUserId(long userId);

    Page<FavoriteEntity> findByUserId(long userId, Pageable pageable);

    List<FavoriteEntity> findByUserIdAndBookId(long userId, long bookId);

    Optional<FavoriteEntity> findOneByUserIdAndId(long userId, long bookId);
}
